import time
import sys

#
if not Misc.CurrentScriptDirectory() in sys.path:
    sys.path.append(Misc.CurrentScriptDirectory())
#    

import common
common.Player = Player
common.Target = Target
common.Items = Items
common.Mobiles = Mobiles
common.Misc = Misc
common.Journal = Journal
common.Statics = Statics
common.Gumps = Gumps
common.Spells = Spells
common.BandageHeal = BandageHeal
#
from System.Collections.Generic import List
from System import Byte, Int32
#
#
def whirlwind_available(weapon):
    if weapon == None:
        return None
    abilities = weapon_abilities()
    if abilities == None:
        return None
    primary = abilities[0]
    secondary = abilities[1]
    if primary == 'Whirlwind Attack':
        #Misc.SendMessage("Returning Whirlwing primary", 5)
        return Player.WeaponPrimarySA
    if secondary == 'Whirlwind Attack':
        return Player.WeaponSecondarySA    
    return None

#
#
import re
def weapon_abilities():
    w_r = Player.GetItemOnLayer('RightHand')
    #Misc.SendMessage("right={}".format(w_r))
    w_l = Player.GetItemOnLayer('LeftHand')
    #Misc.SendMessage("left={}".format(w_l))
    ret = None
    if w_l != None: 
        ret = common.default_weapon_abilities(w_l.ItemID)         
        if ret[0] or ret[1]:
            return ret
    if w_r != None:    
        ret = common.default_weapon_abilities(w_r.ItemID) 
        #Misc.SendMessage("Use right")
    return ret
       

#
def weaponspecials(weapon):
    if weapon == None:
        return None
    abilities = weapon_abilities()
    if not abilities:
        return None
    primary = abilities[0]
    secondary = abilities[1]
    #Misc.SendMessage(primary)
    #Misc.SendMessage(secondary)
    if primary == None:
        return None
    if secondary == None:
        return None 
    primary_priority = 999   
    if primary in common.weapon_ability_priority:
        primary_priority = common.weapon_ability_priority[primary]
    secondary_priority = 999    
    if secondary in common.weapon_ability_priority:    
        secondary_priority = common.weapon_ability_priority[secondary]
    suggest_primary = 999
    suggest_secondary = 999
    #
    if not primary in common.requires_mount or Player.Mount != None:
        suggest_primary = primary_priority
    if not secondary in common.requires_mount or Player.Mount != None:
        suggest_secondary = secondary_priority
    if suggest_primary == 999 and suggest_secondary == 999:
        return None
    if primary == "Infectious Strike" and Player.GetSkillValue("Poisoning") < 10:
        suggest_primary = 999    
    if secondary == "Infectious Strike" and Player.GetSkillValue("Poisoning") < 10:
        suggest_secondary = 999    
    if suggest_primary < suggest_secondary:
        return Player.WeaponPrimarySA
    else:
        return Player.WeaponSecondarySA
#
def Use_weapon_special(weapon):
    #Misc.SendMessage("Action for 1")
    action = weaponspecials(weapon)
    if action != None and not Player.HasSpecial :
        #Misc.SendMessage("Do Action for 1")
        action()

#                        
discord_list = {}
next_discord_time = 0
#
def discord(enemy):
    #return
    global next_discord_time
    global discord_list
    instrumentID = 0xe9c
    drum = Items.FindByID(instrumentID, -1, Player.Backpack.Serial)
    if drum == None:
        return
    if enemy.Serial in discord_list:
        return
    now = time.time()
    if next_discord_time > time.time():
        return
    Journal.Clear()    
    Player.UseSkill('Discordance') 
    next_discord_time = time.time() + 12
    journal_msg = ""
    limit = time.time() + 1
    while time.time() < limit:
        if Journal.Search("Choose the target"):
            journal_msg = "Choose the target"
            limit = 0  # force out of loop
        if Journal.Search("shall you play"):
            journal_msg = "shall you play"
            limit = 0  # force out of loop
    if journal_msg == "":
        Target.Cancel()
        return # wtf ?
    if journal_msg == "shall you play":
        Target.WaitForTarget(500)
        Target.TargetExecute(drum)
        Misc.Pause(100)
    Target.WaitForTarget(500)
    Target.TargetExecute(enemy)
    Misc.Pause(500)
    Target.Cancel()
    if Journal.Search("play jarring music"):
        discord_list[enemy.Serial] = True
    if Journal.Search("no effect"):
        discord_list[enemy.Serial] = True
    if Journal.Search("already in discord"):
        discord_list[enemy.Serial] = True
    return
    
def IsBoss(enemy):
    if enemy is None:
        return False
    name = enemy.Name
    bosses = ['Master', 'Neira', 'rikktor', 'semidar', 'mephitis' ]
    for boss in bosses:
       if boss.upper() in name.upper():
          return True
    return False      
  
    
Misc.ClearIgnore( )
if Misc.CheckSharedValue("Pets"):
    for pet in Misc.ReadSharedValue("Pets"):
        Misc.IgnoreObject(pet)


consecrate = 0
enemyOfOne = 0 
dont_kill = [ 'a cu sidhe', 'a sheep', 'a dog', 'a cat', 'a horse', 'Dart', 'an energy vortex' ]
ignore_type = [0x007b ]
#0x0190, 0x0191, 
last_attack_msg = time.time()
last_attack_serial = 0
#
last_enemy = None
while True:
    #
    enemy_filter = Mobiles.Filter()
    enemy_filter.Enabled = True
    enemy_filter.RangeMin = -1
    if Misc.CheckSharedValue("MaxRange"):
        enemy_filter.RangeMax = Misc.ReadSharedValue("MaxRange")
    else:    
        enemy_filter.RangeMax = 11
    enemy_filter.Notorieties = List[Byte](bytes([3,4,5,6]))

    on_me_filter = Mobiles.Filter()
    on_me_filter.Enabled = True
    on_me_filter.RangeMin = -1
    on_me_filter.RangeMax = 2
    on_me_filter.Notorieties = List[Byte](bytes([3,4,5,6]))
    enemies = Mobiles.ApplyFilter(enemy_filter)
    up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
    #Misc.SendMessage("{} enemies up close".format(len(up_close_enemies)))
    
    w_r = Player.GetItemOnLayer('RightHand')
    #Misc.SendMessage("right={}".format(w_r))
    w_l = Player.GetItemOnLayer('LeftHand')
    #Misc.SendMessage("left={}".format(w_l))
    if w_l != None: 
        weapon = w_l
        Misc.Pause(500)
    elif w_r != None:    
        weapon = w_r
        Misc.Pause(500)
    else:
        weapon = None
    if not BandageHeal.Status() and not Misc.ScriptStatus('Heal_Me.py'):
        if Player.Poisoned or(Player.Hits < (Player.HitsMax * .8)):
            while Player.Poisoned or Player.Hits < (Player.HitsMax * .95):
                if len(enemies) > 0 and Player.WarMode:
                    if len(up_close_enemies) > 2:
                        action = whirlwind_available(weapon)
                        if action != None:
                            #Misc.SendMessage("Whirlwind", 5)
                            action()
                        else:
                            if Player.GetRealSkillValue("Bushido") > 75:
                                b_skill = 'Momentum Strike'
                            elif Player.GetRealSkillValue("Bushido") > 45:
                                b_skill = 'Counter Attack'
                            else:
                                b_skill = 'Confidence'    
                            if not Player.SpellIsEnabled(b_skill):    
                                Misc.SendMessage("casting bushido : {}".format(b_skill), 5)
                                Spells.CastBushido(b_skill)
                                Misc.Pause(500)
                                enemy = Mobiles.Select(enemies, "Weakest")
                        if enemy != None:
                            Player.Attack(enemy)
                            if last_attack_serial != enemy.Serial or time.time() > last_attack_msg + 5:
                                Mobiles.Message(enemy, 5, "Heal Me & Attacking 0x{:08x}".format(enemy.Serial))
                                last_attack_msg = time.time()
                                last_attack_serial = enemy.Serial
                    common.HealMe(wait=False)
                    Misc.Pause(500)

                    #   Misc.SendMessage("Len before is {}".format(len(enemies)))
    #enemies_search = Mobiles.ApplyFilter(enemy_filter)
    #for e in enemies_search:
        #if e.Name in dont_kill:
            #enemies.Find(
            #enemies.Remove(e)
    #Misc.SendMessage("Len after is {}".format(len(enemies)))
    #on_me_filter.RangeMax = 2 
    #on_me_filter.Serials = enemies    
    
    #Misc.SendMessage("Up CLose Enemies after is {}".format(len(up_close_enemies)))
    if len(enemies) > 0:
        #Misc.SendMessage("{} enemies within 10 squares".format(len(enemies)))
        Player.SetWarMode(True)
        if len(up_close_enemies) > 0 and Player.WarMode:
            enemy = Mobiles.Select(up_close_enemies, 'Nearest')
        else:    
            enemy = Mobiles.Select(enemies, 'Nearest')
        if enemy.Name in dont_kill  or enemy.Body in ignore_type or "wandering healer" in enemy.Name:
            Misc.IgnoreObject(enemy.Serial)
            enemy = None
        # ignore energy vortex
        if enemy and enemy.Body == 0x00A4 and enemy.Hue == 0:    
            Misc.IgnoreObject(enemy.Serial)
            enemy = None
        #if enemy == last_enemy or Player.InRangeMobile(enemy, 3):
            #pass
        #else:
            #Player.PathFindTo(enemy.Position.X, enemy.Position.Y, enemy.Position.Z)
            #last_enemy = enemy   
        if enemy != None:
            if last_attack_serial != enemy.Serial or time.time() > last_attack_msg + 5:
                Mobiles.Message(enemy, 5, "Attacking 0x{:08x}".format(enemy.Serial))
                last_attack_msg = time.time()
                last_attack_serial = enemy.Serial
                if False: #enemy.Hits == enemy.HitsMax:
                    Player.InvokeVirtue("Honor")
                    Target.WaitForTarget(1000)
                    Target.TargetExecute(enemy)
            #
            i = Player.GetItemOnLayer("LeftHand")
            #if "shield" in i.Name.lower():
            #    Spells.CastMastery("Shield Bash")
            Player.Attack(enemy.Serial)
            #Target.AttackTargetFromList("attack")
            #Misc.SendMessage("Notoriety is {}".format(enemy.Notoriety)) 
            if Player.GetSkillValue('Bushido') < 45:
                spell = 'Confidence'
            else:
                spell = 'Counter Attack'
            if False: # FIX ME not Player.SpellIsEnabled( spell ):
                Misc.SendMessage("Casting Bushido2: {}".format(spell))
                Spells.CastBushido( spell )
                Misc.Pause(500)   
            #Misc.SendMessage("{} Active".format(spell))
            if len(enemies) < 7:  
                discord(enemy)   
        if Player.Mana > 20:
            if Player.Stam < (.75 * Player.StamMax):
                Journal.Clear()
                Misc.SendMessage("Casting divine fury")
                Spells.CastChivalry("Divine Fury")
                Misc.Pause(500)
            if time.time() > consecrate:
                Misc.SendMessage("Casting consecrate")
                Spells.CastChivalry('Consecrate Weapon')
                consecrate = time.time()+10
                enemyOfOne = max(time.time() + 3, enemyOfOne) 
                # try to change enemy of one no more than every 5 seconds
                
            if False: # time.time() > enemyOfOne and Player.GetRealSkillValue("Chivalry") >= 45:
                Misc.SendMessage("casting Enemy Of One")
                if enemy and enemy.Notoriety != 5:
                    Spells.CastChivalry('Enemy Of One')
                    enemyOfOne = time.time() + 10           

            if not Player.HasSpecial:
                w_r = Player.GetItemOnLayer('RightHand')
                #Misc.SendMessage("right={}".format(w_r))
                w_l = Player.GetItemOnLayer('LeftHand')
                #Misc.SendMessage("left={}".format(w_l))
                if w_l != None: 
                    weapon = w_l
                    Misc.Pause(500)
                elif w_r != None:    
                    weapon = w_r
                    Misc.Pause(500)
                else:
                    weapon = None
                #
                range = Items.GetPropValue(weapon, 'Range') 
                if range < 2:
                    range = 2         
                on_me_filter.RangeMax = range          
                up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
                #
                num_up_close_enemies = len(up_close_enemies) 
                if IsBoss(enemy):
                    num_up_close_enemies = 1
                use_momentum = True
                if Misc.CheckSharedValue("UseMomentum"):
                    use_momentum = Misc.ReadSharedValue("UseMomentum")
                if  num_up_close_enemies > 2:
                    action = whirlwind_available(weapon)
                    if action != None:
                        #Misc.SendMessage("Whirlwind", 5)
                        action()
                    else:
                        if use_momentum and (not Player.SpellIsEnabled('Momentum Strike')):    
                            Misc.SendMessage("Momentum Strike", 5)
                            Spells.CastBushido('Momentum Strike')
                            Misc.Pause(500)
                        else:
                            Use_weapon_special(weapon)
                elif len(up_close_enemies) == 2:
                    if use_momentum and (not Player.SpellIsEnabled('Momentum Strike')):     
                        Misc.SendMessage("Momentum Strike", 5)
                        Spells.CastBushido('Momentum Strike')
                        Misc.Pause(800)
                    else:
                        Use_weapon_special(weapon)
                elif not Player.HasSpecial and Player.Mana > 30:                    
                    Use_weapon_special(weapon)
    #
    #if not BandageHeal.Status() and not Misc.ScriptStatus('Heal_Me.py'):
    #    if Player.Poisoned or(Player.Hits < (Player.HitsMax * .95)):
    #            common.HealMe(wait=False)
    # move things to boh if possible 
    if False:  #len(enemies) == 0 or Player.Weight > (.4 * Player.MaxWeight):
        if Misc.CheckSharedValue("BagOfHolding"):
            bagOfHolding = Misc.ReadSharedValue("BagOfHolding")
            boh_types = [0x0E1F, 0x1bdd, 0x1bfb, 0x19b9, 0x1081, 0x26b4, 0xeed, 0x9f1, 0x318f, 0x3190, 0x3191, 0xf3f,  0xe21]    
            boh_items = []
            for i in common.findRecursive(Player.Backpack.Serial, boh_types):
                if i.Container != bagOfHolding:                
                    boh_items.append(i)
            #boh_items = [i for i in boh_items if i.ItemID != 0xe24 or i.Hue == 0]
            for item in boh_items:            
                if Items.GetPropStringByIndex(item, 1).lower() != "blessed":
                    Items.Move(item.Serial, bagOfHolding, 0)
                    Misc.Pause(800)
        discord_list = {}    
#                      
    if Player.Weight > (.8 * Player.MaxWeight) or len(Player.Backpack.Contains) > 80 :
        Player.HeadMessage(1, "Heavy") 
    Misc.Pause(100)


